package de.cscherr.mcpht;

import de.cscherr.mcpht.config.MCPHTConfig;
import me.shedaniel.autoconfig.AutoConfig;
import net.fabricmc.api.ClientModInitializer;
import me.shedaniel.autoconfig.serializer.JanksonConfigSerializer;
import net.minecraft.client.MinecraftClient;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.regex.Pattern;

public class MCPHTClient implements ClientModInitializer {
	public static final String MOD_ID = "mcpht";
	public static final Logger LOGGER = LoggerFactory.getLogger(MOD_ID);
	public static MCPHTConfig CONFIG;
	public static XRay XRAY;
	public static Pattern networkPacketFilter;
	public static MinecraftClient MC;

	@Override
	public void onInitializeClient() {
		MC = MinecraftClient.getInstance();
		AutoConfig.register(MCPHTConfig.class, JanksonConfigSerializer::new);
		// This entrypoint is suitable for setting up client-specific logic, such as rendering.
		CONFIG = AutoConfig.getConfigHolder(MCPHTConfig.class).getConfig();
		AutoConfig.getConfigHolder(MCPHTConfig.class).registerSaveListener((configHolder, mcphtConfig) -> {
			MCPHTConfig conf = AutoConfig.getConfigHolder(MCPHTConfig.class).getConfig();
			conf.onSave();
            return null;
        });
		AutoConfig.getConfigHolder(MCPHTConfig.class).registerLoadListener((configHolder, mcphtConfig) -> {
			MCPHTConfig conf = AutoConfig.getConfigHolder(MCPHTConfig.class).getConfig();
			conf.onLoad();
			return null;
		});
		CONFIG.onLoad();
		XRAY = new XRay();
		XRAY.init();
		LOGGER.info("Init client!");
	}
}