package de.cscherr.mcpht;

import net.fabricmc.fabric.api.client.event.lifecycle.v1.ClientTickEvents;
import net.fabricmc.fabric.api.client.keybinding.v1.KeyBindingHelper;
import net.minecraft.block.Block;
import net.minecraft.block.BlockState;
import net.minecraft.block.Blocks;
import net.minecraft.client.option.KeyBinding;
import net.minecraft.client.util.InputUtil;
import org.lwjgl.glfw.GLFW;

import java.util.ArrayList;
import java.util.List;

public class XRay {
    public boolean enable = true;
    public ArrayList<Block> whitelistBlocks = new ArrayList<>(
            List.of(
                    // Ores
                    Blocks.COAL_ORE,
                    Blocks.COPPER_ORE,
                    Blocks.IRON_ORE,
                    Blocks.GOLD_ORE,
                    Blocks.LAPIS_ORE,
                    Blocks.DIAMOND_ORE,
                    Blocks.EMERALD_ORE,
                    Blocks.REDSTONE_ORE,
                    Blocks.ANCIENT_DEBRIS,

                    // Deepslate Ores
                    Blocks.DEEPSLATE_COAL_ORE,
                    Blocks.DEEPSLATE_COPPER_ORE,
                    Blocks.DEEPSLATE_IRON_ORE,
                    Blocks.DEEPSLATE_GOLD_ORE,
                    Blocks.DEEPSLATE_LAPIS_ORE,
                    Blocks.DEEPSLATE_DIAMOND_ORE,
                    Blocks.DEEPSLATE_EMERALD_ORE,
                    Blocks.DEEPSLATE_REDSTONE_ORE,

                    // Resource Blocks
                    Blocks.COAL_BLOCK,
                    Blocks.COPPER_BLOCK,
                    Blocks.IRON_BLOCK,
                    Blocks.GOLD_BLOCK,
                    Blocks.LAPIS_BLOCK,
                    Blocks.DIAMOND_BLOCK,
                    Blocks.REDSTONE_BLOCK,

                    // Crafting stuff
                    Blocks.CHEST,
                    Blocks.ENDER_CHEST,
                    Blocks.TRAPPED_CHEST,
                    Blocks.ENCHANTING_TABLE,
                    Blocks.FURNACE,
                    Blocks.BLAST_FURNACE,
                    Blocks.ANVIL,
                    Blocks.HOPPER,
                    Blocks.BEACON,

                    // Danger
                    Blocks.TNT,
                    Blocks.SPAWNER,

                    // Shulker Boxes
                    // FIXME: Add the ones I forgot
                    Blocks.SHULKER_BOX,
                    Blocks.GREEN_SHULKER_BOX,
                    Blocks.YELLOW_SHULKER_BOX,
                    Blocks.BLACK_SHULKER_BOX,
                    Blocks.BLUE_SHULKER_BOX,
                    Blocks.BROWN_SHULKER_BOX,
                    Blocks.CYAN_SHULKER_BOX,
                    Blocks.GRAY_SHULKER_BOX,
                    Blocks.LIGHT_BLUE_SHULKER_BOX,
                    Blocks.LIGHT_GRAY_SHULKER_BOX,
                    Blocks.LIME_SHULKER_BOX,
                    Blocks.ORANGE_SHULKER_BOX,
                    Blocks.PINK_SHULKER_BOX,
                    Blocks.WHITE_SHULKER_BOX,
                    Blocks.RED_SHULKER_BOX
            )
    );
    private static KeyBinding toggleKey;

    public void init() {
        toggleKey = KeyBindingHelper.registerKeyBinding(new KeyBinding(
                "key.mcpht.toggleXray",     // Translation of name
                InputUtil.Type.KEYSYM,      // Type: MOUSE or KESYM (Keyboard)
                GLFW.GLFW_KEY_X,            // The keycode of the key (default?)
                "category.mcpht.rendering"  // Translation key for the keybinding category
        ));
        ClientTickEvents.END_CLIENT_TICK.register(client -> {
            // NOTE: IDK why we need a while here
            while (toggleKey.wasPressed()) {
                if (MCPHTClient.XRAY.getEnable()) {
                    MCPHTClient.LOGGER.info(String.format("toggle XRay: %s", MCPHTClient.XRAY.enable));
                    MCPHTClient.XRAY.enable = !MCPHTClient.XRAY.enable;
                    MCPHTClient.MC.worldRenderer.reload();
                }
            }
        });
    }

    public boolean showRenderBlock(BlockState state) {
        return whitelistBlocks.contains(state.getBlock());
    }

    public boolean getEnable() {
        return enable && MCPHTClient.CONFIG.xRay.enable;
    }
}